diff -ruN freeswan-1.9.orig/lib/pfkey_v2_parse.c freeswan-1.9/lib/pfkey_v2_parse.c
--- freeswan-1.9.orig/lib/pfkey_v2_parse.c	Fri Dec  1 02:09:00 2000
+++ freeswan-1.9/lib/pfkey_v2_parse.c	Wed May 16 10:57:20 2001
@@ -12,14 +12,14 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: pfkey_v2_parse.c,v 1.31 2000/12/01 07:09:00 rgb Exp $
+ * RCSID $Id: pfkey_v2_parse.c,v 1.35 2001/05/03 19:44:51 rgb Exp $
  */
 
 /*
  *		Template from klips/net/ipsec/ipsec/ipsec_parser.c.
  */
 
-char pfkey_v2_parse_c_version[] = "$Id: pfkey_v2_parse.c,v 1.31 2000/12/01 07:09:00 rgb Exp $";
+char pfkey_v2_parse_c_version[] = "$Id: pfkey_v2_parse.c,v 1.35 2001/05/03 19:44:51 rgb Exp $";
 
 /*
  * Some ugly stuff to allow consistent debugging code for use in the
@@ -43,12 +43,14 @@
 # endif /* if defined(CONFIG_IPV6) || defined(CONFIG_IPV6_MODULE) */
 extern int debug_pfkey;
 
+# include <freeswan.h>
 #else /* __KERNEL__ */
 
 # include <sys/types.h>
 # include <linux/types.h>
 # include <linux/errno.h>
 
+# include <freeswan.h>
 # include "../pluto/constants.h" 
 # include "../pluto/defs.h"  /* for PRINTF_LIKE */
 # include "../pluto/log.h"  /* for debugging and DBG_log */
@@ -66,7 +68,6 @@
 #endif /* __KERNEL__ */
 
 
-#include <freeswan.h>
 #include <pfkeyv2.h>
 #include <pfkey.h>
 
@@ -94,13 +95,15 @@
 #ifdef CONFIG_IPSEC_IPCOMP
 	{ IPPROTO_COMP,	SADB_X_SATYPE_COMP,	"COMP" },
 #endif /* CONFIG_IPSEC_IPCOMP */
+	{ IPPROTO_INT,	SADB_X_SATYPE_INT,	"INT" },
 #else /* __KERNEL__ */
 	{ SA_ESP,	SADB_SATYPE_ESP,	"ESP"  },
 	{ SA_AH,	SADB_SATYPE_AH,		"AH"   },
 	{ SA_IPIP,	SADB_X_SATYPE_IPIP,	"IPIP" },
 	{ SA_COMP,	SADB_X_SATYPE_COMP,	"COMP" },
+	{ SA_INT,	SADB_X_SATYPE_INT,	"INT" },
 #endif /* __KERNEL__ */
-	{ 0, 0 }
+	{ 0,		0,			"UNKNOWN" }
 };
 
 uint8_t satype2proto(uint8_t satype) {
@@ -121,6 +124,15 @@
 	return satype_tbl[i].satype;
 }
 
+char* satype2name(uint8_t satype) {
+	int i = 0;
+
+	while(satype_tbl[i].satype != satype && satype_tbl[i].satype != 0) {
+		i++;
+	}
+	return satype_tbl[i].name;
+}
+
 char* proto2name(uint8_t proto) {
 	int i = 0;
 
@@ -130,38 +142,6 @@
 	return satype_tbl[i].name;
 }
 
-uint8_t sadb_satype2proto[] = {
-#ifdef __KERNEL__
-	0,
-	0,
-	IPPROTO_AH,
-	IPPROTO_ESP,
-	0,
-	0,
-	0,
-	0,
-	0,
-	IPPROTO_IPIP,
-#ifdef CONFIG_IPSEC_IPCOMP
-	IPPROTO_COMP
-#else /* CONFIG_IPSEC_IPCOMP */
-	0
-#endif /* CONFIG_IPSEC_IPCOMP */
-#else /* __KERNEL__ */
-	0,
-	0,
-	SA_AH,
-	SA_ESP,
-	0,
-	0,
-	0,
-	0,
-	0,
-	SA_IPIP,
-	SA_COMP
-#endif /* __KERNEL__ */
-};
-
 /* Default extension parsers taken from the KLIPS code */
 
 DEBUG_NO_STATIC int
@@ -175,13 +155,15 @@
 	/* sanity checks... */
 	if(!pfkey_sa) {
 		DEBUGGING(
-			"pfkey_sa_parse: NULL pointer passed in.\n");
+			"pfkey_sa_parse: "
+			"NULL pointer passed in.\n");
 		SENDERR(EINVAL);
 	}
 	
 	if(pfkey_sa->sadb_sa_len != sizeof(struct sadb_sa) / IPSEC_PFKEYv2_ALIGN) {
 		DEBUGGING(
-			"pfkey_sa_parse: length wrong pfkey_sa->sadb_sa_len=%d sizeof(struct sadb_sa)=%d.\n",
+			"pfkey_sa_parse: "
+			"length wrong pfkey_sa->sadb_sa_len=%d sizeof(struct sadb_sa)=%d.\n",
 			pfkey_sa->sadb_sa_len,
 			sizeof(struct sadb_sa));
 		SENDERR(EINVAL);
@@ -189,7 +171,8 @@
 	
 	if(pfkey_sa->sadb_sa_encrypt > SADB_EALG_MAX) {
 		DEBUGGING(
-			"pfkey_sa_parse: pfkey_sa->sadb_sa_encrypt=%d > SADB_EALG_MAX=%d.\n",
+			"pfkey_sa_parse: "
+			"pfkey_sa->sadb_sa_encrypt=%d > SADB_EALG_MAX=%d.\n",
 			pfkey_sa->sadb_sa_encrypt,
 			SADB_EALG_MAX);
 		SENDERR(EINVAL);
@@ -197,7 +180,8 @@
 	
 	if(pfkey_sa->sadb_sa_auth > SADB_AALG_MAX) {
 		DEBUGGING(
-			"pfkey_sa_parse: pfkey_sa->sadb_sa_auth=%d > SADB_AALG_MAX=%d.\n",
+			"pfkey_sa_parse: "
+			"pfkey_sa->sadb_sa_auth=%d > SADB_AALG_MAX=%d.\n",
 			pfkey_sa->sadb_sa_auth,
 			SADB_AALG_MAX);
 		SENDERR(EINVAL);
@@ -205,7 +189,8 @@
 	
 	if(pfkey_sa->sadb_sa_state > SADB_SASTATE_MAX) {
 		DEBUGGING(
-			"pfkey_sa_parse: state=%d exceeds MAX=%d.\n",
+			"pfkey_sa_parse: "
+			"state=%d exceeds MAX=%d.\n",
 			pfkey_sa->sadb_sa_state,
 			SADB_SASTATE_MAX);
 		SENDERR(EINVAL);
@@ -213,7 +198,8 @@
 	
 	if(pfkey_sa->sadb_sa_state == SADB_SASTATE_DEAD) {
 		DEBUGGING(
-			"pfkey_sa_parse: state=%d is DEAD=%d.\n",
+			"pfkey_sa_parse: "
+			"state=%d is DEAD=%d.\n",
 			pfkey_sa->sadb_sa_state,
 			SADB_SASTATE_DEAD);
 		SENDERR(EINVAL);
@@ -221,8 +207,8 @@
 	
 	if(pfkey_sa->sadb_sa_replay > 64) {
 		DEBUGGING(
-			"pfkey_sa_parse: replay window size: %d"
-			" -- must be 0 <= size <= 64\n",
+			"pfkey_sa_parse: "
+			"replay window size: %d -- must be 0 <= size <= 64\n",
 			pfkey_sa->sadb_sa_replay);
 		SENDERR(EINVAL);
 	}
@@ -231,14 +217,16 @@
 	      (pfkey_sa->sadb_sa_exttype ==  SADB_X_EXT_SA2)))
 	{
 		DEBUGGING(
-			"pfkey_sa_parse: unknown exttype=%d, expecting SADB_EXT_SA=%d or SADB_X_EXT_SA2=%d.\n",
+			"pfkey_sa_parse: "
+			"unknown exttype=%d, expecting SADB_EXT_SA=%d or SADB_X_EXT_SA2=%d.\n",
 			pfkey_sa->sadb_sa_exttype,
 			SADB_EXT_SA,
 			SADB_X_EXT_SA2);
 		SENDERR(EINVAL);
 	}
 	DEBUGGING(
-		"pfkey_sa_parse: successfully found len=%d exttype=%d spi=%08lx replay=%d state=%d auth=%d encrypt=%d flags=%d.\n",
+		"pfkey_sa_parse: "
+		"successfully found len=%d exttype=%d spi=%08lx replay=%d state=%d auth=%d encrypt=%d flags=%d.\n",
 		pfkey_sa->sadb_sa_len,
 		pfkey_sa->sadb_sa_exttype,
 		(long unsigned int)ntohl(pfkey_sa->sadb_sa_spi),
@@ -263,14 +251,16 @@
 	/* sanity checks... */
 	if(!pfkey_lifetime) {
 		DEBUGGING(
-			"pfkey_lifetime_parse: NULL pointer passed in.\n");
+			"pfkey_lifetime_parse: "
+			"NULL pointer passed in.\n");
 		SENDERR(EINVAL);
 	}
 
 	if(pfkey_lifetime->sadb_lifetime_len !=
 	   sizeof(struct sadb_lifetime) / IPSEC_PFKEYv2_ALIGN) {
 		DEBUGGING(
-			"pfkey_lifetime_parse: length wrong pfkey_lifetime->sadb_lifetime_len=%d sizeof(struct sadb_lifetime)=%d.\n",
+			"pfkey_lifetime_parse: "
+			"length wrong pfkey_lifetime->sadb_lifetime_len=%d sizeof(struct sadb_lifetime)=%d.\n",
 			pfkey_lifetime->sadb_lifetime_len,
 			sizeof(struct sadb_lifetime));
 		SENDERR(EINVAL);
@@ -280,7 +270,8 @@
 	   (pfkey_lifetime->sadb_lifetime_exttype != SADB_EXT_LIFETIME_SOFT) &&
 	   (pfkey_lifetime->sadb_lifetime_exttype != SADB_EXT_LIFETIME_CURRENT)) {
 		DEBUGGING( 
-			"pfkey_lifetime_parse: unexpected ext_type=%d.\n", 
+			"pfkey_lifetime_parse: "
+			"unexpected ext_type=%d.\n", 
 			pfkey_lifetime->sadb_lifetime_exttype); 
 		SENDERR(EINVAL);
 	}
@@ -303,7 +294,8 @@
 	/* sanity checks... */
 	if(!pfkey_address) {
 		DEBUGGING(
-			"pfkey_address_parse: NULL pointer passed in.\n");
+			"pfkey_address_parse: "
+			"NULL pointer passed in.\n");
 		SENDERR(EINVAL);
 	}
 	
@@ -311,7 +303,8 @@
 	   (sizeof(struct sadb_address) + sizeof(struct sockaddr))/
 	   IPSEC_PFKEYv2_ALIGN) {
 		DEBUGGING(
-			"pfkey_address_parse: size wrong 1 ext_len=%d, adr_ext_len=%d, saddr_len=%d.\n",
+			"pfkey_address_parse: "
+			"size wrong 1 ext_len=%d, adr_ext_len=%d, saddr_len=%d.\n",
 			pfkey_address->sadb_address_len,
 			sizeof(struct sadb_address),
 			sizeof(struct sockaddr));
@@ -320,7 +313,8 @@
 	
 	if(pfkey_address->sadb_address_reserved) {
 		DEBUGGING(
-			"pfkey_address_parse: res=%d, must be zero.\n",
+			"pfkey_address_parse: "
+			"res=%d, must be zero.\n",
 			pfkey_address->sadb_address_reserved);
 		SENDERR(EINVAL);
 	}
@@ -337,7 +331,8 @@
 		break;
 	default:
 		DEBUGGING( 
-			"pfkey_address_parse: unexpected ext_type=%d.\n", 
+			"pfkey_address_parse: "
+			"unexpected ext_type=%d.\n", 
 			pfkey_address->sadb_address_exttype); 
 		SENDERR(EINVAL); 
 	}
@@ -345,7 +340,8 @@
 	switch(s->sa_family) {
 	case AF_INET:
 		DEBUGGING(
-			"pfkey_address_parse: found address family=%d, AF_INET.\n",
+			"pfkey_address_parse: "
+			"found address family=%d, AF_INET.\n",
 			s->sa_family);
 		saddr_len = sizeof(struct sockaddr_in);
 		sprintf(ipaddr_txt, "%d.%d.%d.%d"
@@ -354,12 +350,14 @@
 			, (((struct sockaddr_in*)s)->sin_addr.s_addr >> 16) & 0xFF
 			, (((struct sockaddr_in*)s)->sin_addr.s_addr >> 24) & 0xFF);
 		DEBUGGING(
-			"pfkey_address_parse: found address=%s.\n",
+			"pfkey_address_parse: "
+			"found address=%s.\n",
 			ipaddr_txt);
 		break;
 	case AF_INET6:
 		DEBUGGING(
-			"pfkey_address_parse: found address family=%d, AF_INET6.\n",
+			"pfkey_address_parse: "
+			"found address family=%d, AF_INET6.\n",
 			s->sa_family);
 		saddr_len = sizeof(struct sockaddr_in6);
 		sprintf(ipaddr_txt, "%x:%x:%x:%x:%x:%x:%x:%x"
@@ -372,12 +370,14 @@
 			, ntohs(((struct sockaddr_in6*)s)->sin6_addr.s6_addr16[6])
 			, ntohs(((struct sockaddr_in6*)s)->sin6_addr.s6_addr16[7]));
 		DEBUGGING(
-			"pfkey_address_parse: found address=%s.\n",
+			"pfkey_address_parse: "
+			"found address=%s.\n",
 			ipaddr_txt);
 		break;
 	default:
 		DEBUGGING(
-			"pfkey_address_parse: s->sa_family=%d not supported.\n",
+			"pfkey_address_parse: "
+			"s->sa_family=%d not supported.\n",
 			s->sa_family);
 		SENDERR(EPFNOSUPPORT);
 	}
@@ -385,7 +385,8 @@
 	if(pfkey_address->sadb_address_len !=
 	   DIVUP(sizeof(struct sadb_address) + saddr_len, IPSEC_PFKEYv2_ALIGN)) {
 		DEBUGGING(
-			"pfkey_address_parse: size wrong 2 ext_len=%d, adr_ext_len=%d, saddr_len=%d.\n",
+			"pfkey_address_parse: "
+			"size wrong 2 ext_len=%d, adr_ext_len=%d, saddr_len=%d.\n",
 			pfkey_address->sadb_address_len,
 			sizeof(struct sadb_address),
 			saddr_len);
@@ -394,7 +395,8 @@
 	
 	if(pfkey_address->sadb_address_prefixlen != 0) {
 		DEBUGGING(
-			"pfkey_address_parse: address prefixes not supported yet.\n");
+			"pfkey_address_parse: "
+			"address prefixes not supported yet.\n");
 		SENDERR(EAFNOSUPPORT); /* not supported yet */
 	}
 	
@@ -418,13 +420,15 @@
 
 	if(!pfkey_key) {
 		DEBUGGING(
-			"pfkey_key_parse: NULL pointer passed in.\n");
+			"pfkey_key_parse: "
+			"NULL pointer passed in.\n");
 		SENDERR(EINVAL);
 	}
 
 	if(pfkey_key->sadb_key_len < sizeof(struct sadb_key) / IPSEC_PFKEYv2_ALIGN) {
 		DEBUGGING(
-			"pfkey_key_parse: size wrong ext_len=%d, key_ext_len=%d.\n",
+			"pfkey_key_parse: "
+			"size wrong ext_len=%d, key_ext_len=%d.\n",
 			pfkey_key->sadb_key_len,
 			sizeof(struct sadb_key));
 		SENDERR(EINVAL);
@@ -432,7 +436,8 @@
 
 	if(!pfkey_key->sadb_key_bits) {
 		DEBUGGING(
-			"pfkey_key_parse: key length set to zero, must be non-zero.\n");
+			"pfkey_key_parse: "
+			"key length set to zero, must be non-zero.\n");
 		SENDERR(EINVAL);
 	}
 
@@ -440,7 +445,8 @@
 	   DIVUP(sizeof(struct sadb_key) * OCTETBITS + pfkey_key->sadb_key_bits,
 		 PFKEYBITS)) {
 		DEBUGGING(
-			"pfkey_key_parse: key length=%d does not agree with extension length=%d.\n",
+			"pfkey_key_parse: "
+			"key length=%d does not agree with extension length=%d.\n",
 			pfkey_key->sadb_key_bits,
 			pfkey_key->sadb_key_len);
 		SENDERR(EINVAL);
@@ -448,7 +454,8 @@
 	
 	if(pfkey_key->sadb_key_reserved) {
 		DEBUGGING(
-			"pfkey_key_parse: res=%d, must be zero.\n",
+			"pfkey_key_parse: "
+			"res=%d, must be zero.\n",
 			pfkey_key->sadb_key_reserved);
 		SENDERR(EINVAL);
 	}
@@ -456,13 +463,15 @@
 	if(! ( (pfkey_key->sadb_key_exttype == SADB_EXT_KEY_AUTH) ||
 	       (pfkey_key->sadb_key_exttype == SADB_EXT_KEY_ENCRYPT))) {
 		DEBUGGING(
-			"pfkey_key_parse: expecting extension type AUTH or ENCRYPT, got %d.\n",
+			"pfkey_key_parse: "
+			"expecting extension type AUTH or ENCRYPT, got %d.\n",
 			pfkey_key->sadb_key_exttype);
 		SENDERR(EINVAL);
 	}
 
 	DEBUGGING(
-		"pfkey_key_parse: success, found len=%d exttype=%d bits=%d reserved=%d.\n",
+		"pfkey_key_parse: "
+		"success, found len=%d exttype=%d bits=%d reserved=%d.\n",
 		pfkey_key->sadb_key_len,
 		pfkey_key->sadb_key_exttype,
 		pfkey_key->sadb_key_bits,
@@ -481,7 +490,8 @@
 	/* sanity checks... */
 	if(pfkey_ident->sadb_ident_len < sizeof(struct sadb_ident) / IPSEC_PFKEYv2_ALIGN) {
 		DEBUGGING(
-			"pfkey_ident_parse: size wrong ext_len=%d, key_ext_len=%d.\n",
+			"pfkey_ident_parse: "
+			"size wrong ext_len=%d, key_ext_len=%d.\n",
 			pfkey_ident->sadb_ident_len,
 			sizeof(struct sadb_ident));
 		SENDERR(EINVAL);
@@ -489,7 +499,8 @@
 
 	if(pfkey_ident->sadb_ident_type > SADB_IDENTTYPE_MAX) {
 		DEBUGGING(
-			"pfkey_ident_parse: ident_type=%d out of range, must be less than %d.\n",
+			"pfkey_ident_parse: "
+			"ident_type=%d out of range, must be less than %d.\n",
 			pfkey_ident->sadb_ident_type,
 			SADB_IDENTTYPE_MAX);
 		SENDERR(EINVAL);
@@ -497,7 +508,8 @@
 
 	if(pfkey_ident->sadb_ident_reserved) {
 		DEBUGGING(
-			"pfkey_ident_parse: res=%d, must be zero.\n",
+			"pfkey_ident_parse: "
+			"res=%d, must be zero.\n",
 			pfkey_ident->sadb_ident_reserved);
 		SENDERR(EINVAL);
 	}
@@ -506,7 +518,8 @@
 	if(pfkey_ident->sadb_ident_len > sizeof(struct sadb_ident) / IPSEC_PFKEYv2_ALIGN) {
 		if(*((char*)pfkey_ident + pfkey_ident->sadb_ident_len * IPSEC_PFKEYv2_ALIGN - 1)) {
 			DEBUGGING(
-				"pfkey_ident_parse: string padding must be zero, last is 0x%02x.\n",
+				"pfkey_ident_parse: "
+				"string padding must be zero, last is 0x%02x.\n",
 				*((char*)pfkey_ident +
 				  pfkey_ident->sadb_ident_len * IPSEC_PFKEYv2_ALIGN - 1));
 			SENDERR(EINVAL);
@@ -516,7 +529,8 @@
 	if( ! ((pfkey_ident->sadb_ident_exttype == SADB_EXT_IDENTITY_SRC) ||
 	       (pfkey_ident->sadb_ident_exttype == SADB_EXT_IDENTITY_DST))) {
 		DEBUGGING(
-			"pfkey_key_parse: expecting extension type IDENTITY_SRC or IDENTITY_DST, got %d.\n",
+			"pfkey_key_parse: "
+			"expecting extension type IDENTITY_SRC or IDENTITY_DST, got %d.\n",
 			pfkey_ident->sadb_ident_exttype);
 		SENDERR(EINVAL);
 	}
@@ -534,14 +548,16 @@
 	/* sanity checks... */
 	if(pfkey_sens->sadb_sens_len < sizeof(struct sadb_sens) / IPSEC_PFKEYv2_ALIGN) {
 		DEBUGGING(
-			"pfkey_sens_parse: size wrong ext_len=%d, key_ext_len=%d.\n",
+			"pfkey_sens_parse: "
+			"size wrong ext_len=%d, key_ext_len=%d.\n",
 			pfkey_sens->sadb_sens_len,
 			sizeof(struct sadb_sens));
 		SENDERR(EINVAL);
 	}
 
 	DEBUGGING(
-		"pfkey_sens_parse: Sorry, I can't parse exttype=%d yet.\n",
+		"pfkey_sens_parse: "
+		"Sorry, I can't parse exttype=%d yet.\n",
 		pfkey_ext->sadb_ext_type);
 #if 0
 	SENDERR(EINVAL); /* don't process these yet */
@@ -563,7 +579,8 @@
 	if((pfkey_prop->sadb_prop_len < sizeof(struct sadb_prop) / IPSEC_PFKEYv2_ALIGN) || 
 	   (((pfkey_prop->sadb_prop_len * IPSEC_PFKEYv2_ALIGN) - sizeof(struct sadb_prop)) % sizeof(struct sadb_comb))) {
 		DEBUGGING(
-			"pfkey_prop_parse: size wrong ext_len=%d, prop_ext_len=%d comb_ext_len=%d.\n",
+			"pfkey_prop_parse: "
+			"size wrong ext_len=%d, prop_ext_len=%d comb_ext_len=%d.\n",
 			pfkey_prop->sadb_prop_len,
 			sizeof(struct sadb_prop),
 			sizeof(struct sadb_comb));
@@ -572,8 +589,8 @@
 
 	if(pfkey_prop->sadb_prop_replay > 64) {
 		DEBUGGING(
-			"pfkey_prop_parse: replay window size: %d"
-			" -- must be 0 <= size <= 64\n",
+			"pfkey_prop_parse: "
+			"replay window size: %d -- must be 0 <= size <= 64\n",
 			pfkey_prop->sadb_prop_replay);
 		SENDERR(EINVAL);
 	}
@@ -581,7 +598,8 @@
 	for(i=0; i<3; i++) {
 		if(pfkey_prop->sadb_prop_reserved[i]) {
 			DEBUGGING(
-				"pfkey_prop_parse: res[%d]=%d, must be zero.\n",
+				"pfkey_prop_parse: "
+				"res[%d]=%d, must be zero.\n",
 				i, pfkey_prop->sadb_prop_reserved[i]);
 			SENDERR(EINVAL);
 		}
@@ -592,7 +610,8 @@
 	for(i = 0; i < num_comb; i++) {
 		if(pfkey_comb->sadb_comb_auth > SADB_AALG_MAX) {
 			DEBUGGING(
-				"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_auth=%d > SADB_AALG_MAX=%d.\n",
+				"pfkey_prop_parse: "
+				"pfkey_comb[%d]->sadb_comb_auth=%d > SADB_AALG_MAX=%d.\n",
 				i,
 				pfkey_comb->sadb_comb_auth,
 				SADB_AALG_MAX);
@@ -602,19 +621,22 @@
 		if(pfkey_comb->sadb_comb_auth) {
 			if(!pfkey_comb->sadb_comb_auth_minbits) {
 				DEBUGGING(
-					"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_auth_minbits=0, fatal.\n",
+					"pfkey_prop_parse: "
+					"pfkey_comb[%d]->sadb_comb_auth_minbits=0, fatal.\n",
 					i);
 				SENDERR(EINVAL);
 			}
 			if(!pfkey_comb->sadb_comb_auth_maxbits) {
 				DEBUGGING(
-					"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_auth_maxbits=0, fatal.\n",
+					"pfkey_prop_parse: "
+					"pfkey_comb[%d]->sadb_comb_auth_maxbits=0, fatal.\n",
 					i);
 				SENDERR(EINVAL);
 			}
 			if(pfkey_comb->sadb_comb_auth_minbits > pfkey_comb->sadb_comb_auth_maxbits) {
 				DEBUGGING(
-					"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_auth_minbits=%d > maxbits=%d, fatal.\n",
+					"pfkey_prop_parse: "
+					"pfkey_comb[%d]->sadb_comb_auth_minbits=%d > maxbits=%d, fatal.\n",
 					i,
 					pfkey_comb->sadb_comb_auth_minbits,
 					pfkey_comb->sadb_comb_auth_maxbits);
@@ -623,14 +645,16 @@
 		} else {
 			if(pfkey_comb->sadb_comb_auth_minbits) {
 				DEBUGGING(
-					"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_auth_minbits=%d != 0, fatal.\n",
+					"pfkey_prop_parse: "
+					"pfkey_comb[%d]->sadb_comb_auth_minbits=%d != 0, fatal.\n",
 					i,
 					pfkey_comb->sadb_comb_auth_minbits);
 				SENDERR(EINVAL);
 			}
 			if(pfkey_comb->sadb_comb_auth_maxbits) {
 				DEBUGGING(
-					"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_auth_maxbits=%d != 0, fatal.\n",
+					"pfkey_prop_parse: "
+					"pfkey_comb[%d]->sadb_comb_auth_maxbits=%d != 0, fatal.\n",
 					i,
 					pfkey_comb->sadb_comb_auth_maxbits);
 				SENDERR(EINVAL);
@@ -639,7 +663,8 @@
 
 		if(pfkey_comb->sadb_comb_encrypt > SADB_EALG_MAX) {
 			DEBUGGING(
-				"pfkey_comb_parse: pfkey_comb[%d]->sadb_comb_encrypt=%d > SADB_EALG_MAX=%d.\n",
+				"pfkey_comb_parse: "
+				"pfkey_comb[%d]->sadb_comb_encrypt=%d > SADB_EALG_MAX=%d.\n",
 				i,
 				pfkey_comb->sadb_comb_encrypt,
 				SADB_EALG_MAX);
@@ -649,19 +674,22 @@
 		if(pfkey_comb->sadb_comb_encrypt) {
 			if(!pfkey_comb->sadb_comb_encrypt_minbits) {
 				DEBUGGING(
-					"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_encrypt_minbits=0, fatal.\n",
+					"pfkey_prop_parse: "
+					"pfkey_comb[%d]->sadb_comb_encrypt_minbits=0, fatal.\n",
 					i);
 				SENDERR(EINVAL);
 			}
 			if(!pfkey_comb->sadb_comb_encrypt_maxbits) {
 				DEBUGGING(
-					"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_encrypt_maxbits=0, fatal.\n",
+					"pfkey_prop_parse: "
+					"pfkey_comb[%d]->sadb_comb_encrypt_maxbits=0, fatal.\n",
 					i);
 				SENDERR(EINVAL);
 			}
 			if(pfkey_comb->sadb_comb_encrypt_minbits > pfkey_comb->sadb_comb_encrypt_maxbits) {
 				DEBUGGING(
-					"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_encrypt_minbits=%d > maxbits=%d, fatal.\n",
+					"pfkey_prop_parse: "
+					"pfkey_comb[%d]->sadb_comb_encrypt_minbits=%d > maxbits=%d, fatal.\n",
 					i,
 					pfkey_comb->sadb_comb_encrypt_minbits,
 					pfkey_comb->sadb_comb_encrypt_maxbits);
@@ -670,14 +698,16 @@
 		} else {
 			if(pfkey_comb->sadb_comb_encrypt_minbits) {
 				DEBUGGING(
-					"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_encrypt_minbits=%d != 0, fatal.\n",
+					"pfkey_prop_parse: "
+					"pfkey_comb[%d]->sadb_comb_encrypt_minbits=%d != 0, fatal.\n",
 					i,
 					pfkey_comb->sadb_comb_encrypt_minbits);
 				SENDERR(EINVAL);
 			}
 			if(pfkey_comb->sadb_comb_encrypt_maxbits) {
 				DEBUGGING(
-					"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_encrypt_maxbits=%d != 0, fatal.\n",
+					"pfkey_prop_parse: "
+					"pfkey_comb[%d]->sadb_comb_encrypt_maxbits=%d != 0, fatal.\n",
 					i,
 					pfkey_comb->sadb_comb_encrypt_maxbits);
 				SENDERR(EINVAL);
@@ -688,7 +718,8 @@
 
 		if(pfkey_comb->sadb_comb_hard_allocations && pfkey_comb->sadb_comb_soft_allocations > pfkey_comb->sadb_comb_hard_allocations) {
 			DEBUGGING(
-				"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_soft_allocations=%d > hard_allocations=%d, fatal.\n",
+				"pfkey_prop_parse: "
+				"pfkey_comb[%d]->sadb_comb_soft_allocations=%d > hard_allocations=%d, fatal.\n",
 				i,
 				pfkey_comb->sadb_comb_soft_allocations,
 				pfkey_comb->sadb_comb_hard_allocations);
@@ -697,7 +728,8 @@
 
 		if(pfkey_comb->sadb_comb_hard_bytes && pfkey_comb->sadb_comb_soft_bytes > pfkey_comb->sadb_comb_hard_bytes) {
 			DEBUGGING(
-				"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_soft_bytes=%Ld > hard_bytes=%Ld, fatal.\n",
+				"pfkey_prop_parse: "
+				"pfkey_comb[%d]->sadb_comb_soft_bytes=%Ld > hard_bytes=%Ld, fatal.\n",
 				i,
 				pfkey_comb->sadb_comb_soft_bytes,
 				pfkey_comb->sadb_comb_hard_bytes);
@@ -706,7 +738,8 @@
 
 		if(pfkey_comb->sadb_comb_hard_addtime && pfkey_comb->sadb_comb_soft_addtime > pfkey_comb->sadb_comb_hard_addtime) {
 			DEBUGGING(
-				"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_soft_addtime=%Ld > hard_addtime=%Ld, fatal.\n",
+				"pfkey_prop_parse: "
+				"pfkey_comb[%d]->sadb_comb_soft_addtime=%Ld > hard_addtime=%Ld, fatal.\n",
 				i,
 				pfkey_comb->sadb_comb_soft_addtime,
 				pfkey_comb->sadb_comb_hard_addtime);
@@ -715,7 +748,8 @@
 
 		if(pfkey_comb->sadb_comb_hard_usetime && pfkey_comb->sadb_comb_soft_usetime > pfkey_comb->sadb_comb_hard_usetime) {
 			DEBUGGING(
-				"pfkey_prop_parse: pfkey_comb[%d]->sadb_comb_soft_usetime=%Ld > hard_usetime=%Ld, fatal.\n",
+				"pfkey_prop_parse: "
+				"pfkey_comb[%d]->sadb_comb_soft_usetime=%Ld > hard_usetime=%Ld, fatal.\n",
 				i,
 				pfkey_comb->sadb_comb_soft_usetime,
 				pfkey_comb->sadb_comb_hard_usetime);
@@ -724,7 +758,8 @@
 
 		if(pfkey_comb->sadb_comb_reserved) {
 			DEBUGGING(
-				"pfkey_prop_parse: comb[%d].res=%d, must be zero.\n",
+				"pfkey_prop_parse: "
+				"comb[%d].res=%d, must be zero.\n",
 				i,
 				pfkey_comb->sadb_comb_reserved);
 			SENDERR(EINVAL);
@@ -751,7 +786,8 @@
 	     sizeof(struct sadb_supported)) % sizeof(struct sadb_alg))) {
 
 		DEBUGGING(
-			"pfkey_supported_parse: size wrong ext_len=%d, supported_ext_len=%d alg_ext_len=%d.\n",
+			"pfkey_supported_parse: "
+			"size wrong ext_len=%d, supported_ext_len=%d alg_ext_len=%d.\n",
 			pfkey_supported->sadb_supported_len,
 			sizeof(struct sadb_supported),
 			sizeof(struct sadb_alg));
@@ -760,7 +796,8 @@
 
 	if(pfkey_supported->sadb_supported_reserved) {
 		DEBUGGING(
-			"pfkey_supported_parse: res=%d, must be zero.\n",
+			"pfkey_supported_parse: "
+			"res=%d, must be zero.\n",
 			pfkey_supported->sadb_supported_reserved);
 		SENDERR(EINVAL);
 	}
@@ -771,7 +808,8 @@
 		/* process algo description */
 		if(pfkey_alg->sadb_alg_reserved) {
 			DEBUGGING(
-				"pfkey_supported_parse: alg[%d], id=%d, ivlen=%d, minbits=%d, maxbits=%d, res=%d, must be zero.\n",
+				"pfkey_supported_parse: "
+				"alg[%d], id=%d, ivlen=%d, minbits=%d, maxbits=%d, res=%d, must be zero.\n",
 				i,
 				pfkey_alg->sadb_alg_id,
 				pfkey_alg->sadb_alg_ivlen,
@@ -789,7 +827,8 @@
 		case SADB_EXT_SUPPORTED_AUTH:
 			if(pfkey_alg->sadb_alg_id > SADB_AALG_MAX) {
 				DEBUGGING(
-					"pfkey_supported_parse: alg[%d], alg_id=%d > SADB_AALG_MAX=%d, fatal.\n",
+					"pfkey_supported_parse: "
+					"alg[%d], alg_id=%d > SADB_AALG_MAX=%d, fatal.\n",
 					i,
 					pfkey_alg->sadb_alg_id,
 					SADB_AALG_MAX);
@@ -799,7 +838,8 @@
 		case SADB_EXT_SUPPORTED_ENCRYPT:
 			if(pfkey_alg->sadb_alg_id > SADB_EALG_MAX) {
 				DEBUGGING(
-					"pfkey_supported_parse: alg[%d], alg_id=%d > SADB_EALG_MAX=%d, fatal.\n",
+					"pfkey_supported_parse: "
+					"alg[%d], alg_id=%d > SADB_EALG_MAX=%d, fatal.\n",
 					i,
 					pfkey_alg->sadb_alg_id,
 					SADB_EALG_MAX);
@@ -808,7 +848,8 @@
 			break;
 		default:
 			DEBUGGING(
-				"pfkey_supported_parse: alg[%d], alg_id=%d > SADB_EALG_MAX=%d, fatal.\n",
+				"pfkey_supported_parse: "
+				"alg[%d], alg_id=%d > SADB_EALG_MAX=%d, fatal.\n",
 				i,
 				pfkey_alg->sadb_alg_id,
 				SADB_EALG_MAX);
@@ -831,7 +872,8 @@
         if(pfkey_spirange->sadb_spirange_len !=
 	   sizeof(struct sadb_spirange) / IPSEC_PFKEYv2_ALIGN) {
 		DEBUGGING(
-			"pfkey_spirange_parse: size wrong ext_len=%d, key_ext_len=%d.\n",
+			"pfkey_spirange_parse: "
+			"size wrong ext_len=%d, key_ext_len=%d.\n",
 			pfkey_spirange->sadb_spirange_len,
 			sizeof(struct sadb_spirange));
                 SENDERR(EINVAL);
@@ -839,14 +881,16 @@
 	
         if(pfkey_spirange->sadb_spirange_reserved) {
 		DEBUGGING(
-			" pfkey_spirange_parse: reserved=%d must be set to zero.\n",
+			"pfkey_spirange_parse: "
+			"reserved=%d must be set to zero.\n",
 			pfkey_spirange->sadb_spirange_reserved);
                 SENDERR(EINVAL);
         }
 	
         if(ntohl(pfkey_spirange->sadb_spirange_max) < ntohl(pfkey_spirange->sadb_spirange_min)) {
 		DEBUGGING(
-			" pfkey_spirange_parse: minspi=%08x must be < maxspi=%08x.\n",
+			"pfkey_spirange_parse: "
+			"minspi=%08x must be < maxspi=%08x.\n",
 			ntohl(pfkey_spirange->sadb_spirange_min),
 			ntohl(pfkey_spirange->sadb_spirange_max));
                 SENDERR(EINVAL);
@@ -854,7 +898,8 @@
 	
 	if(ntohl(pfkey_spirange->sadb_spirange_min) <= 255) {
 		DEBUGGING(
-			" pfkey_spirange_parse: minspi=%08x must be > 255.\n",
+			"pfkey_spirange_parse: "
+			"minspi=%08x must be > 255.\n",
 			ntohl(pfkey_spirange->sadb_spirange_min));
 		SENDERR(EEXIST);
 	}
@@ -873,7 +918,8 @@
 	if(pfkey_x_kmprivate->sadb_x_kmprivate_len <
 	   sizeof(struct sadb_x_kmprivate) / IPSEC_PFKEYv2_ALIGN) {
 		DEBUGGING(
-			"pfkey_x_kmprivate_parse: size wrong ext_len=%d, key_ext_len=%d.\n",
+			"pfkey_x_kmprivate_parse: "
+			"size wrong ext_len=%d, key_ext_len=%d.\n",
 			pfkey_x_kmprivate->sadb_x_kmprivate_len,
 			sizeof(struct sadb_x_kmprivate));
 		SENDERR(EINVAL);
@@ -881,13 +927,15 @@
 
 	if(pfkey_x_kmprivate->sadb_x_kmprivate_reserved) {
 		DEBUGGING(
-			" pfkey_x_kmprivate_parse: reserved=%d must be set to zero.\n",
+			"pfkey_x_kmprivate_parse: "
+			"reserved=%d must be set to zero.\n",
 			pfkey_x_kmprivate->sadb_x_kmprivate_reserved);
 		SENDERR(EINVAL);
 	}
 
 	DEBUGGING(
-		"pfkey_x_kmprivate_parse: Sorry, I can't parse exttype=%d yet.\n",
+		"pfkey_x_kmprivate_parse: "
+		"Sorry, I can't parse exttype=%d yet.\n",
 		pfkey_ext->sadb_ext_type);
 	SENDERR(EINVAL); /* don't process these yet */
 
@@ -908,7 +956,8 @@
 	if(pfkey_x_satype->sadb_x_satype_len !=
 	   sizeof(struct sadb_x_satype) / IPSEC_PFKEYv2_ALIGN) {
 		DEBUGGING(
-			"pfkey_x_satype_parse: size wrong ext_len=%d, key_ext_len=%d.\n",
+			"pfkey_x_satype_parse: "
+			"size wrong ext_len=%d, key_ext_len=%d.\n",
 			pfkey_x_satype->sadb_x_satype_len,
 			sizeof(struct sadb_x_satype));
 		SENDERR(EINVAL);
@@ -916,20 +965,23 @@
 	
 	if(!pfkey_x_satype->sadb_x_satype_satype) {
 		DEBUGGING(
-			"pfkey_x_satype_parse: satype is zero, must be non-zero.\n");
+			"pfkey_x_satype_parse: "
+			"satype is zero, must be non-zero.\n");
 		SENDERR(EINVAL);
 	}
 
 	if(pfkey_x_satype->sadb_x_satype_satype > SADB_SATYPE_MAX) {
 		DEBUGGING(
-			"pfkey_x_satype_parse: satype %d > max %d\n", 
+			"pfkey_x_satype_parse: "
+			"satype %d > max %d, invalid.\n", 
 			pfkey_x_satype->sadb_x_satype_satype, SADB_SATYPE_MAX);
 		SENDERR(EINVAL);
 	}
 
 	if(!(satype2proto(pfkey_x_satype->sadb_x_satype_satype))) {
 		DEBUGGING(
-			"pfkey_x_satype_parse: proto lookup from satype=%d failed.\n",
+			"pfkey_x_satype_parse: "
+			"proto lookup from satype=%d failed.\n",
 			pfkey_x_satype->sadb_x_satype_satype);
 		SENDERR(EINVAL);
 	}
@@ -937,7 +989,8 @@
 	for(i = 0; i < 3; i++) {
 		if(pfkey_x_satype->sadb_x_satype_reserved[i]) {
 			DEBUGGING(
-				" pfkey_x_satype_parse: reserved[%d]=%d must be set to zero.\n",
+				"pfkey_x_satype_parse: "
+				"reserved[%d]=%d must be set to zero.\n",
 				i, pfkey_x_satype->sadb_x_satype_reserved[i]);
 			SENDERR(EINVAL);
 		}
@@ -960,7 +1013,8 @@
 	if(pfkey_x_debug->sadb_x_debug_len !=
 	   sizeof(struct sadb_x_debug) / IPSEC_PFKEYv2_ALIGN) {
 		DEBUGGING(
-			"pfkey_x_debug_parse: size wrong ext_len=%d, key_ext_len=%d.\n",
+			"pfkey_x_debug_parse: "
+			"size wrong ext_len=%d, key_ext_len=%d.\n",
 			pfkey_x_debug->sadb_x_debug_len,
 			sizeof(struct sadb_x_debug));
 		SENDERR(EINVAL);
@@ -969,7 +1023,8 @@
 	for(i = 0; i < 4; i++) {
 		if(pfkey_x_debug->sadb_x_debug_reserved[i]) {
 			DEBUGGING(
-				" pfkey_x_debug_parse: reserved[%d]=%d must be set to zero.\n",
+				"pfkey_x_debug_parse: "
+				"reserved[%d]=%d must be set to zero.\n",
 				i, pfkey_x_debug->sadb_x_debug_reserved[i]);
 			SENDERR(EINVAL);
 		}
@@ -1021,12 +1076,13 @@
 	int extensions_seen = 0;
 	
 	DEBUGGING(
-		"pfkey_msg_parse: parsing message "
-		"ver=%d, type=%d, errno=%d, satype=%d, len=%d, res=%d, seq=%d, pid=%d.\n", 
+		"pfkey_msg_parse: "
+		"parsing message ver=%d, type=%d, errno=%d, satype=%d(%s), len=%d, res=%d, seq=%d, pid=%d.\n", 
 		pfkey_msg->sadb_msg_version,
 		pfkey_msg->sadb_msg_type,
 		pfkey_msg->sadb_msg_errno,
 		pfkey_msg->sadb_msg_satype,
+		satype2name(pfkey_msg->sadb_msg_satype),
 		pfkey_msg->sadb_msg_len,
 		pfkey_msg->sadb_msg_reserved,
 		pfkey_msg->sadb_msg_seq,
@@ -1056,13 +1112,15 @@
 
 	if(!pfkey_msg->sadb_msg_type) {
 		DEBUGGING(
-			"pfkey_msg_parse: msg type not set, must be non-zero..\n");
+			"pfkey_msg_parse: "
+			"msg type not set, must be non-zero..\n");
 		SENDERR(EINVAL);
 	}
 
 	if(pfkey_msg->sadb_msg_type > SADB_MAX) {
 		DEBUGGING(
-			"pfkey_msg_parse: msg type=%d > max=%d.\n",
+			"pfkey_msg_parse: "
+			"msg type=%d > max=%d.\n",
 			pfkey_msg->sadb_msg_type,
 			SADB_MAX);
 		SENDERR(EINVAL);
@@ -1074,33 +1132,34 @@
 	case SADB_ADD:
 	case SADB_DELETE:
 	case SADB_GET:
-	case SADB_ACQUIRE:
-	case SADB_REGISTER:
-	case SADB_EXPIRE:
-#if 0
-	case SADB_X_PROMISC:
-	case SADB_X_PCHANGE:
-#endif
 	case SADB_X_GRPSA:
-		if(!pfkey_msg->sadb_msg_satype) {
+	case SADB_X_ADDFLOW:
+		if(!satype2proto(pfkey_msg->sadb_msg_satype)) {
 			DEBUGGING(
-				"pfkey_msg_parse: satype is zero, must be non-zero for msg_type %d.\n", pfkey_msg->sadb_msg_type);
+				"pfkey_msg_parse: "
+				"satype %d conversion to proto failed for msg_type %d.\n",
+				pfkey_msg->sadb_msg_satype,
+				pfkey_msg->sadb_msg_type);
 			SENDERR(EINVAL);
+		} else {
+			DEBUGGING(
+				"pfkey_msg_parse: "
+				"satype %d(%s) conversion to proto gives %d for msg_type %d.\n",
+				pfkey_msg->sadb_msg_satype,
+				satype2name(pfkey_msg->sadb_msg_satype),
+				satype2proto(pfkey_msg->sadb_msg_satype),
+				pfkey_msg->sadb_msg_type);
 		}
-		switch(pfkey_msg->sadb_msg_satype) {
-		case SADB_SATYPE_ESP:
-		case SADB_SATYPE_AH:
-		case SADB_X_SATYPE_IPIP:
-		case SADB_X_SATYPE_COMP:
-			break;
-		default:
+	case SADB_ACQUIRE:
+	case SADB_REGISTER:
+	case SADB_EXPIRE:
+		if(!pfkey_msg->sadb_msg_satype) {
 			DEBUGGING(
 				"pfkey_msg_parse: "
-				"satype=%d is not supported yet.\n",
-				pfkey_msg->sadb_msg_satype);
+				"satype is zero, must be non-zero for msg_type %d.\n",
+				pfkey_msg->sadb_msg_type);
 			SENDERR(EINVAL);
 		}
-		break;
 	default:
 	}
 	
@@ -1115,12 +1174,13 @@
 	}
 
 	DEBUGGING(
-		"pfkey_msg_parse: remain=%d, ext_type=%d, ext_len=%d.\n", 
+		"pfkey_msg_parse: "
+		"remain=%d, ext_type=%d, ext_len=%d.\n", 
 		remain, pfkey_ext->sadb_ext_type, pfkey_ext->sadb_ext_len);
 	
 	DEBUGGING(
-		"pfkey_msg_parse: extensions "
-		"permitted=%08x, required=%08x.\n",
+		"pfkey_msg_parse: "
+		"extensions permitted=%08x, required=%08x.\n",
 		extensions_bitmaps[dir][EXT_BITS_PERM][pfkey_msg->sadb_msg_type],
 		extensions_bitmaps[dir][EXT_BITS_REQ][pfkey_msg->sadb_msg_type]);
 	
@@ -1130,20 +1190,23 @@
 		/* Is there enough message left to support another extension header? */
 		if(remain < pfkey_ext->sadb_ext_len) {
 			DEBUGGING(
-				"pfkey_msg_parse: remain %d less than ext len %d.\n", 
+				"pfkey_msg_parse: "
+				"remain %d less than ext len %d.\n", 
 				remain, pfkey_ext->sadb_ext_len);
 			SENDERR(EINVAL);
 		}
 		
 		DEBUGGING(
-			"pfkey_msg_parse: parsing ext type=%d remain=%d.\n",
+			"pfkey_msg_parse: "
+			"parsing ext type=%d remain=%d.\n",
 			pfkey_ext->sadb_ext_type,
 			remain);
 		
 		/* Is the extension header type valid? */
 		if((pfkey_ext->sadb_ext_type > SADB_EXT_MAX) || (!pfkey_ext->sadb_ext_type)) {
 			DEBUGGING(
-				"pfkey_msg_parse: ext type %d invalid, SADB_EXT_MAX=%d.\n", 
+				"pfkey_msg_parse: "
+				"ext type %d invalid, SADB_EXT_MAX=%d.\n", 
 				pfkey_ext->sadb_ext_type, SADB_EXT_MAX);
 			SENDERR(EINVAL);
 		}
